<?xml version="1.0" encoding="UTF-8"?>
<databaseChangeLog
        xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
        xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
        xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-3.1.xsd">

    <changeSet id="#16-1" author="Duy">
        <preConditions onFail="MARK_RAN">
            <not>
                <tableExists tableName="USER"/>
            </not>
        </preConditions>
        <createTable tableName="USER">
            <column autoIncrement="true" name="ID" type="BIGINT">
                <constraints primaryKey="true"/>
            </column>
            <column name="CREATEDON" type="TIMESTAMP"/>
            <column name="UPDATEDON" type="TIMESTAMP"/>
            <column name="USERNAME" type="VARCHAR(255)"/>
            <column name="PASSWORD" type="VARCHAR(255)"/>
            <column name="TELNUMBER" type="VARCHAR(255)"/>
            <column name="EMAIL" type="VARCHAR(255)"/>
        </createTable>
        <addUniqueConstraint tableName="USER" columnNames="USERNAME"/>
        <addNotNullConstraint tableName="USER" columnName="USERNAME" columnDataType="VARCHAR(255)"/>
        <addNotNullConstraint tableName="USER" columnName="PASSWORD" columnDataType="VARCHAR(255)"/>
    </changeSet>
    <changeSet id="#16-2" author="Duy">
        <preConditions onFail="MARK_RAN">
            <not>
                <tableExists tableName="PERSON"/>
            </not>
        </preConditions>
        <createTable tableName="PERSON">
            <column name="ID" type="BIGINT">
                <constraints primaryKey="true"/>
            </column>
            <column name="FIRSTNAME" type="VARCHAR(255)"/>
            <column name="LASTNAME" type="VARCHAR(255)"/>
            <column name="BIRTHDATE" type="DATE"/>
        </createTable>
        <addUniqueConstraint tableName="PERSON" columnNames="FIRSTNAME, LASTNAME"/>
        <addNotNullConstraint tableName="PERSON" columnName="FIRSTNAME" columnDataType="VARCHAR(255)"/>
        <addNotNullConstraint tableName="PERSON" columnName="LASTNAME" columnDataType="VARCHAR(255)"/>
        <addNotNullConstraint tableName="PERSON" columnName="BIRTHDATE" columnDataType="DATE"/>
        <addForeignKeyConstraint baseTableName="PERSON" baseColumnNames="ID" constraintName="fk_person_user"
                                 referencedTableName="USER" referencedColumnNames="ID" onDelete="CASCADE"/>
    </changeSet>
    <changeSet id="#16-3" author="Duy">
        <preConditions onFail="MARK_RAN">
            <not>
                <tableExists tableName="ORGANIZATION"/>
            </not>
        </preConditions>
        <createTable tableName="ORGANIZATION">
            <column name="ID" type="BIGINT">
                <constraints primaryKey="true"/>
            </column>
            <column name="NAME" type="VARCHAR(255)"/>
            <column name="UID" type="VARCHAR(255)"/>
        </createTable>
        <addUniqueConstraint tableName="ORGANIZATION" columnNames="UID"/>
        <addNotNullConstraint tableName="ORGANIZATION" columnName="UID" columnDataType="VARCHAR(255)"/>
        <addNotNullConstraint tableName="ORGANIZATION" columnName="NAME" columnDataType="VARCHAR(255)"/>
        <addForeignKeyConstraint baseTableName="ORGANIZATION" baseColumnNames="ID" constraintName="fk_organization_user"
                                 referencedTableName="USER" referencedColumnNames="ID" onDelete="CASCADE"/>
    </changeSet>
    <changeSet id="#16-4" author="Duy">
        <preConditions onFail="MARK_RAN">
            <not>
                <tableExists tableName="ACCOUNT"/>
            </not>
        </preConditions>
        <createTable tableName="ACCOUNT">
            <column autoIncrement="true" name="ID" type="BIGINT">
                <constraints primaryKey="true"/>
            </column>
            <column name="CREATEDON" type="TIMESTAMP"/>
            <column name="UPDATEDON" type="TIMESTAMP"/>
            <column name="ACCID" type="VARCHAR(255)"/>
            <column name="NAME" type="VARCHAR(255)"/>
            <column name="BALANCE" type="DOUBLE"/>
        </createTable>
        <addUniqueConstraint tableName="ACCOUNT" columnNames="ACCID"/>
        <addNotNullConstraint tableName="ACCOUNT" columnName="ACCID" columnDataType="VARCHAR(255)"/>
    </changeSet>
    <changeSet id="#16-5" author="Duy">
        <preConditions onFail="MARK_RAN">
            <not>
                <tableExists tableName="USER_ACCOUNT"/>
            </not>
        </preConditions>
        <createTable tableName="USER_ACCOUNT">
            <column name="USER_ID" type="BIGINT"/>
            <column name="ACCOUNT_ID" type="BIGINT"/>
        </createTable>
        <addForeignKeyConstraint baseTableName="USER_ACCOUNT" baseColumnNames="USER_ID"
                                 constraintName="fk_userAccount_user"
                                 referencedTableName="USER" referencedColumnNames="ID" onDelete="CASCADE"/>
        <addForeignKeyConstraint baseTableName="USER_ACCOUNT" baseColumnNames="ACCOUNT_ID"
                                 constraintName="fk_userAccount_account"
                                 referencedTableName="ACCOUNT" referencedColumnNames="ID" onDelete="CASCADE"/>
    </changeSet>
    <changeSet id="#16-6" author="Duy">
        <preConditions onFail="MARK_RAN">
            <not>
                <tableExists tableName="ADDRESS"/>
            </not>
        </preConditions>
        <createTable tableName="ADDRESS">
            <column autoIncrement="true" name="ID" type="BIGINT">
                <constraints primaryKey="true"/>
            </column>
            <column name="CREATEDON" type="TIMESTAMP"/>
            <column name="UPDATEDON" type="TIMESTAMP"/>
            <column name="STREET" type="VARCHAR(255)"/>
            <column name="HOUSENUMBER" type="VARCHAR(255)"/>
            <column name="ZIPCODE" type="VARCHAR(255)"/>
            <column name="PLACE" type="VARCHAR(255)"/>
            <column name="COUNTRY" type="VARCHAR(255)"/>
            <column name="STAIR" type="VARCHAR(255)"/>
            <column name="DOORNUMBER" type="VARCHAR(255)"/>
        </createTable>
        <addNotNullConstraint tableName="ADDRESS" columnName="STREET" columnDataType="VARCHAR(255)"/>
        <addNotNullConstraint tableName="ADDRESS" columnName="HOUSENUMBER" columnDataType="VARCHAR(255)"/>
        <addNotNullConstraint tableName="ADDRESS" columnName="ZIPCODE" columnDataType="VARCHAR(255)"/>
        <addNotNullConstraint tableName="ADDRESS" columnName="PLACE" columnDataType="VARCHAR(255)"/>
    </changeSet>
    <changeSet id="#16-7" author="Duy">
        <preConditions onFail="MARK_RAN">
            <not>
                <tableExists tableName="USER_ADDRESS"/>
            </not>
        </preConditions>
        <createTable tableName="USER_ADDRESS">
            <column name="USER_ID" type="BIGINT"/>
            <column name="ADDRESS_ID" type="BIGINT"/>
        </createTable>
        <addForeignKeyConstraint baseTableName="USER_ADDRESS" baseColumnNames="USER_ID"
                                 constraintName="fk_userAddress_user"
                                 referencedTableName="USER" referencedColumnNames="ID" onDelete="CASCADE"/>
        <addForeignKeyConstraint baseTableName="USER_ADDRESS" baseColumnNames="ADDRESS_ID"
                                 constraintName="fk_userAccount_address"
                                 referencedTableName="ADDRESS" referencedColumnNames="ID" onDelete="CASCADE"/>
    </changeSet>
</databaseChangeLog>